<?php
/**
* Eike
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2007 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modContentItemHelper
{
	function getList(&$params)
	{
		global $mainframe;
		JPluginHelper::importPlugin('content');
		
	  $dispatcher	   =& JEventDispatcher::getInstance();
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$userId		= (int) $user->get('id');
		$show_front	= $params->get('show_front', 1);			
		$aid		= $user->get('aid', 0);
		$count		= (int) $params->get('count', false);

//Item, cat, section
   	$type		= trim( $params->get('type') );
//  ID or comma separated lists of ids
   	$showbyid		= trim( $params->get('showbyid') );

// map id to type 
   $cimid = $catid = $secid = false;
   switch($type) {
	  // Items
	 // Cats
	  case '3':
		 $secid = true;		
		 if($params->get("show_section") == 1) {
		  $params->set('section',1);
		 }
		break;
	  case '2':
		 $catid = true;
		 if($params->get("show_category") == 1) {
		  $params->set('category',1);
		 }
		break;
	  case '1':
		default:
		 $cimid = true;
		break; 
	 }    				

		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access		= !$contentConfig->get('shownoauth');

		$nullDate	= $db->getNullDate();
		$now		= date('Y-m-d H:i:s', time());

		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;

		// User Filter
		switch ($params->get( 'user_id' ))
		{
			case 'by_me':
				$where .= ' AND (created_by = ' . (int) $userId . ' OR modified_by = ' . (int) $userId . ')';
				break;
			case 'not_me':
				$where .= ' AND (created_by <> ' . (int) $userId . ' AND modified_by <> ' . (int) $userId . ')';
				break;
		}

		// Ordering
		switch ($params->get( 'ordering' ))
		{
			case 'm_dsc':
				$ordering		= 'a.modified DESC, a.created DESC';
				break;
			case 'c_dsc':
			default:
				$ordering		= 'a.created DESC';
				break;
		}

		$Condition = "";
		if ($cimid)
		{
			$ids = explode( ',',  $showbyid );
			JArrayHelper::toInteger( $ids );
			$Condition = ' AND (a.id=' . implode( ' OR a.id=', $ids ) . ')';
		}		
		
		if ($catid)
		{
			$ids = explode( ',',  $showbyid );
			JArrayHelper::toInteger( $ids );
			$Condition = ' AND (cc.id=' . implode( ' OR cc.id=', $ids ) . ')';
		}
		if ($secid)
		{
			$ids = explode( ',',  $showbyid );
			JArrayHelper::toInteger( $ids );
			$Condition = ' AND (s.id=' . implode( ' OR s.id=', $ids ) . ')';
		}
		
		// Content Items only
		$query = 'SELECT a.*, ' .
			' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
			' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
			' , cc.id as catid, cc.description as category ' .
			' , s.id as sectionid, s.description as section' .			
			' FROM #__content AS a' .
			($show_front == '0' ? ' LEFT JOIN #__content_frontpage AS f ON f.content_id = a.id' : '') .
			' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
			' INNER JOIN #__sections AS s ON s.id = a.sectionid' .
			' WHERE '. $where .' AND s.id > 0' .
			($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
			$Condition . 
			($show_front == '0' ? ' AND f.content_id IS NULL ' : '').
			' AND s.published = 1' .
			' AND cc.published = 1' .
			' ORDER BY '. $ordering;
		
		// echo str_replace("#_","jos",$query);
		if($count) {
		 $db->setQuery($query, 0, $count);
		} else {
		 $db->setQuery($query);		
		}
		$rows = $db->loadObjectList();
    foreach( $rows as $row) {
		 if($params->get( 'show_intro' )) {
		  $row->text = $row->introtext;			
			if($row->fulltext) {
			 $row->readmore_link = ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid);
		   $row->readmore_text = "weiterlesen";
			}			
		 } else {
		  $row->text = $row->introtext . $row->fulltext;		
		 }
		 $row->event = new stdClass();
		 $results = $dispatcher->trigger('onPrepareContent', array (& $row, & $params));		 
		 $results = $dispatcher->trigger('onAfterDisplayTitle', array ($row, &$params));
		 $row->event->afterDisplayTitle = trim(implode("\n", $results));
		 $results = $dispatcher->trigger('onBeforeDisplayContent', array (& $row, & $params));
		 $row->event->beforeDisplayContent = trim(implode("\n", $results));
		 $results = $dispatcher->trigger('onAfterDisplayContent', array (& $row, & $params));
		 $row->event->afterDisplayContent = trim(implode("\n", $results));		 
		}
				
 // echo '<pre>';print_r($rows);   echo '</pre>';	 
		return $rows;
	}
}
